prologin/www/concours/stechec/urls.py
from concours.stechec import views
from django.conf.urls.defaults import patterns, include, url
from django.contrib.auth.decorators import login_required
from django.contrib.auth import views as auth_views
from django.views.generic import TemplateView

urlpatterns = patterns('concours.stechec',
    url(r'^$', login_required(TemplateView.as_view(template_name='index.html')), name="index"),
    url(r'^login/$', auth_views.login, { 'template_name': 'login.html' }, name="login"),
    url(r'^logout/$', auth_views.logout, { 'next_page': '/' }, name="logout"),

    url(r'^champions/(?P<pk>\d+)/$', views.ChampionView.as_view(), name="champion-detail"),
    url(r'^champions/all/$', views.AllChampionsView.as_view(), name="champions-all"),
    url(r'^champions/my/$', login_required(views.MyChampionsView.as_view()), name="champions-my"),
    url(r'^champions/new/$', login_required(views.new_champion), name="champion-new"),
    url(r'^champions/delete/(?P<pk>\d+)/$', login_required(views.delete_champion), name="champion-delete"),

    url(r'^matches/(?P<pk>\d+?)/$', views.MatchView.as_view(), name="match-detail"),
    url(r'^matches/(?P<pk>\d+?)/dump/$', views.match_dump, name="match-dump"),
    url(r'^matches/all/$', views.AllMatchesView.as_view(), name="matches-all"),
    url(r'^matches/my/$', login_required(views.MyMatchesView.as_view()), name="matches-my"),
    url(r'^matches/new/$', login_required(views.new_match), name="match-new"),

    url(r'^maps/(?P<pk>\d+?)/$', views.MapView.as_view(), name="map-detail"),
    url(r'^maps/all/$', views.AllMapsView.as_view(), name="maps-all"),
    url(r'^maps/new/$', login_required(views.new_map), name="map-new"),

    url(r'^status/$', views.master_status, name="status"),
)

prologin/www/concours/urls.py
from django.conf.urls.defaults import patterns, include, url
from django.contrib import admin

import concours.stechec.urls

admin.autodiscover()

urlpatterns = patterns('',
    url(r'^admin/doc/', include('django.contrib.admindocs.urls')),
    url(r'^admin/', include(admin.site.urls)),
    url(r'^', include(concours.stechec.urls)),
)

prologin/www/concours/stechec/models.py
# -*- coding: utf-8 -*-

from django.conf import settings
from django.contrib.auth import models as auth
from django.core.urlresolvers import reverse
from django.db import models

import os.path
import re
import xmlrpclib

stripper_re = re.compile(r'\033\[.*?m')
def strip_ansi_codes(t):
    return stripper_re.sub('', t)

class Map(models.Model):
    author = models.ForeignKey(auth.User, verbose_name="auteur")
    name = models.CharField("nom", max_length=100)
    official = models.BooleanField("officielle", default=False)
    ts = models.DateTimeField("date", auto_now_add=True)

    @property
    def path(self):
        contest_dir = os.path.join(settings.STECHEC_ROOT, settings.STECHEC_CONTEST)
        maps_dir = os.path.join(contest_dir, "maps")
        return os.path.join(maps_dir, str(self.id))

    @property
    def contents(self):
        return open(self.path).read()

    @contents.setter
    def contents(self, value):
        open(self.path, 'w').write(value)

    def get_absolute_url(self):
        return reverse("map-detail", kwargs={"pk": self.id})

    def __unicode__(self):
        return u"%s, de %s%s" % (self.name, self.author,
                                 u" (officielle)" if self.official else u"")

    class Meta:
        ordering = ["-official", "-ts"]
        verbose_name = "map"
        verbose_name_plural = "maps"

class Champion(models.Model):
    STATUS_CHOICES = (
        ('new', 'En attente de compilation'),
        ('pending', 'En cours de compilation'),
        ('ready', 'Compilé et prêt'),
        ('error', 'Erreur de compilation'),
    )

    name = models.CharField("nom", max_length=100)
    author = models.ForeignKey(auth.User, verbose_name="auteur")
    status = models.CharField("statut", choices=STATUS_CHOICES,
                              max_length=100, default="new")
    deleted = models.BooleanField("supprimé", default=False)
    comment = models.TextField("commentaire")
    ts = models.DateTimeField("date", auto_now_add=True)

    @property
    def directory(self):
        contest_dir = os.path.join(settings.STECHEC_ROOT, settings.STECHEC_CONTEST)
        champions_dir = os.path.join(contest_dir, "champions")
        return os.path.join(champions_dir, self.author.username, str(self.id))

    @property
    def compilation_log(self):
        this_dir = self.directory
        try:
            return open(os.path.join(this_dir, "compilation.log")).read().decode('iso-8859-15')
        except Exception, e:
            return str(e)

    def get_absolute_url(self):
        return reverse('champion-detail', kwargs={'pk': self.id})

    def get_delete_url(self):
        return reverse('champion-delete', kwargs={'pk': self.id})

    def __unicode__(self):
        return u"%s, de %s" % (self.name, self.author)

    class Meta:
        ordering = ['-ts']
        verbose_name = "champion"
        verbose_name_plural = "champions"

class Tournament(models.Model):
    name = models.CharField("nom", max_length=100)
    ts = models.DateTimeField("date", auto_now_add=True)
    players = models.ManyToManyField(Champion, verbose_name="participants",
                                     through="TournamentPlayer")

    def __unicode__(self):
        return u"%s, %s" % (self.name, self.ts)

    class Meta:
        ordering = ['-ts']
        verbose_name = "tournoi"
        verbose_name_plural = "tournois"

class TournamentPlayer(models.Model):
    champion = models.ForeignKey(Champion, verbose_name="champion")
    tournament = models.ForeignKey(Tournament, verbose_name="tournoi")
    score = models.IntegerField("score", default=0)

    def __unicode__(self):
        return u"%s pour tournoi %s" % (self.champion, self.tournament)

    class Meta:
        ordering = ["-tournament", "-score"]
        verbose_name = "participant à un tournoi"
        verbose_name_plural = "participants à un tournoi"

class Match(models.Model):
    STATUS_CHOICES = (
        ('creating', 'En cours de création'),
        ('new', 'En attente de lancement'),
        ('pending', 'En cours de calcul'),
        ('done', 'Terminé'),
    )

    author = models.ForeignKey(auth.User, verbose_name="lancé par")
    status = models.CharField("statut", choices=STATUS_CHOICES, max_length=100,
                              default="creating")
    tournament = models.ForeignKey(Tournament, verbose_name="tournoi",
                                   null=True, blank=True)
    players = models.ManyToManyField(Champion, verbose_name="participants",
                                     through="MatchPlayer")
    options = models.CharField("options", max_length=500)
    ts = models.DateTimeField("date", auto_now_add=True)

    @property
    def directory(self):
        contest_dir = os.path.join(settings.STECHEC_ROOT, settings.STECHEC_CONTEST)
        matches_dir = os.path.join(contest_dir, "matches")
        hi_id = "%03d" % (self.id / 1000)
        low_id = "%03d" % (self.id % 1000)
        return os.path.join(matches_dir, hi_id, low_id)

    @property
    def log(self):
        log_path = os.path.join(self.directory, "server.log")
        try:
            t = open(log_path).read().decode('iso-8859-15')
            return strip_ansi_codes(t)
        except Exception, e:
            return str(e)

    @property
    def dump(self):
        dump_path = os.path.join(self.directory, "dump.json.gz")
        return open(dump_path, "rb").read()

    @property
    def options_dict(self):
        opts = {}
        for line in self.options.split('\n'):
            if '=' not in line:
                continue
            name, value = line.split('=', 1)
            opts[name.strip()] = value.strip()
        return opts

    @options_dict.setter
    def options_dict(self, value):
        self.options = '\n'.join('%s=%s' % t for t in value.iteritems())

    @property
    def map(self):
        return self.options_dict.get('map', '')

    @map.setter
    def map(self, value):
        d = self.options_dict
        d['map'] = value
        self.options_dict = d

    @property
    def is_done(self):
        return self.status == 'done'

    def get_absolute_url(self):
        return reverse('match-detail', kwargs={'pk': self.id})

    def __unicode__(self):
        return u"%s (par %s)" % (self.ts, self.author)

    class Meta:
        ordering = ["-ts"]
        verbose_name = "match"
        verbose_name_plural = "matches"

class MatchPlayer(models.Model):
    champion = models.ForeignKey(Champion, verbose_name="champion")
    match = models.ForeignKey(Match, verbose_name="match")
    score = models.IntegerField("score", default=0)

    @property
    def log(self):
        filename = "log-champ-%d-%d.log" % (self.id, self.champion.id)
        try:
            t = open(os.path.join(self.match.directory, filename)).read().decode('iso-8859-15')
            return strip_ansi_codes(t)
        except Exception, e:
            return str(e)

    def __unicode__(self):
        return u"%s pour match %s" % (self.champion, self.match)

    class Meta:
        ordering = ["-match"]
        verbose_name = "participant à un match"
        verbose_name_plural = "participants à un match"

def master_status():
    rpc = xmlrpclib.ServerProxy(settings.STECHEC_MASTER)
    return rpc.status()

prologin/www/concours/stechec/views.py
# -*- encoding: utf-8 -*-

from concours.stechec import forms
from concours.stechec import models
from django.conf import settings
from django.core.urlresolvers import reverse
from django.db.models import Max, Min
from django.http import HttpResponseRedirect, HttpResponse
from django.shortcuts import render_to_response, get_object_or_404
from django.template import RequestContext
from django.views.generic import DetailView, ListView

import os
import os.path

class ChampionView(DetailView):
    context_object_name = "champion"
    model = models.Champion
    template_name = "champion-detail.html"

    @property
    def can_see_log(self):
        ch = self.get_object()
        return self.request.user == ch.author or self.request.user.is_staff

    def get_context_data(self, **kwargs):
        context = super(ChampionView, self).get_context_data(**kwargs)
        context['can_see_log'] = self.can_see_log
        return context

class ChampionsListView(ListView):
    context_object_name = "champions"
    paginate_by = 50
    template_name = "champions-list.html"

    def get_context_data(self, **kwargs):
        context = super(ChampionsListView, self).get_context_data(**kwargs)
        context['show_for_all'] = self.show_for_all
        context['explanation_text'] = self.explanation_text
        return context

class AllChampionsView(ChampionsListView):
    queryset = models.Champion.objects.filter(deleted=False)
    explanation_text = 'Voici la liste de tous les champions participants actuellement.'
    show_for_all = True

class MyChampionsView(ChampionsListView):
    explanation_text = 'Voici la liste de tous vos champions participants actuellement.'
    show_for_all = False

    def get_queryset(self):
        user = self.request.user
        return models.Champion.objects.filter(deleted=False, author=user)

class MatchesListView(ListView):
    context_object_name = "matches"
    paginate_by = 100
    template_name = "matches-list.html"

    def get_context_data(self, **kwargs):
        context = super(MatchesListView, self).get_context_data(**kwargs)
        context['explanation_text'] = self.explanation_text
        context['show_creator'] = self.show_creator
        matches = []
        for m in context['matches']:
            try:
                map_id = int(m.map.split('/')[-1])
                map_name = models.Map.objects.get(pk=map_id).name
            except Exception:
                map_name = m.map
            matches.append((m, map_name))
        context['matches'] = matches
        return context

class MatchView(DetailView):
    context_object_name = "match"
    template_name = "match-detail.html"
    queryset = models.Match.objects.annotate(Max('matchplayer__score')).annotate(Min('matchplayer__id'))

class AllMatchesView(MatchesListView):
    queryset = models.Match.objects.all()
    explanation_text = "Voici la liste de tous les matches ayant été réalisés."
    show_creator = True

class MyMatchesView(MatchesListView):
    explanation_text = "Voici la liste des matches que vous avez lancé."
    show_creator = False

    def get_queryset(self):
        user = self.request.user
        return models.Match.objects.filter(author=user)

class AllMapsView(ListView):
    context_object_name = "maps"
    paginate_by = 100
    template_name = "maps-list.html"
    queryset = models.Map.objects.order_by('-official', '-id')

class MapView(DetailView):
    context_object_name = "map"
    template_name = "map-detail.html"
    model = models.Map

def new_champion(request):
    if request.method == 'POST':
        form = forms.ChampionUploadForm(request.POST, request.FILES)
        if form.is_valid():
            champion = models.Champion(
                name = form.cleaned_data['name'],
                author = request.user,
                status = 'new',
                comment = form.cleaned_data['comment']
            )
            champion.save()

            os.makedirs(champion.directory)
            fp = open(os.path.join(champion.directory, 'champion.tgz'), 'w')
            for chunk in form.cleaned_data['tarball'].chunks():
                fp.write(chunk)
            fp.close()
            return HttpResponseRedirect(champion.get_absolute_url())
    else:
        form = forms.ChampionUploadForm()

    return render_to_response('champion-new.html', {'form': form},
                              context_instance=RequestContext(request))

def delete_champion(request, pk):
    ch = get_object_or_404(models.Champion, pk=pk, author=request.user)
    if request.method == 'POST':
        ch.deleted = True
        ch.save()
        return HttpResponseRedirect(reverse("champions-my"))
    return render_to_response('champion-delete.html',
                              context_instance=RequestContext(request))

def new_match(request):
    if request.method == 'POST':
        form = forms.MatchCreationForm(request.POST)
        if form.is_valid():
            match = models.Match(
                author=request.user,
                status='creating',
                tournament=None,
                options=''
            )
            match.map = form.cleaned_data['map'].path
            match.save()

            for i in xrange(1, settings.STECHEC_NPLAYERS + 1):
                champ = form.cleaned_data['champion_%d' % i]
                player = models.MatchPlayer(
                    champion=champ,
                    match=match
                )
                player.save()

            match.status = 'new'
            match.save()
            return HttpResponseRedirect(match.get_absolute_url())
    else:
        form = forms.MatchCreationForm()

    return render_to_response('match-new.html', {'form': form},
                              context_instance=RequestContext(request))

def match_dump(request, pk):
    match = get_object_or_404(models.Match, pk=pk)
    h = HttpResponse(match.dump, mimetype="application/stechec-dump")
    h['Content-Disposition'] = 'attachment; filename=dump-%s.json.gz' % pk
    return h

def new_map(request):
    if request.method == 'POST':
        form = forms.MapCreationForm(request.POST)
        if form.is_valid():
            map = models.Map(
                author = request.user,
                name = form.cleaned_data['name'],
                official = False
            )
            map.save()
            map.contents = form.cleaned_data['contents']
            return HttpResponseRedirect(map.get_absolute_url())
    else:
        form = forms.MapCreationForm()

    return render_to_response('map-new.html', {'form': form},
                              context_instance=RequestContext(request))

def master_status(request):
    status = models.master_status()
    status = [(h, p, (100 * (m - s)) / m) for (h, p, s, m) in status]
    status.sort()
    return render_to_response('master-status.html', {'status': status},
                              context_instance=RequestContext(request))

prologin/www/concours/stechec/templates/base.html
<!DOCTYPE html>

<html lang="fr">
    <head>
        <meta charset="utf-8">
        <title>Prologin - {% block "title" %}{% endblock %}</title>

        <link rel="stylesheet" title="Main" href="{{ STATIC_URL }}css/main.css" type="text/css" media="screen">
        {% block "head" %}{% endblock %}
    </head>
    <body>
        <header>
            <div id="logo">&nbsp;</div>
            <h1>{% block "titleh1" %}{% endblock %}</h1>
        </header>
        <nav>
            <div class="block">
                <h1>Champions</h1>
                <ul>
                    {% if user.is_authenticated %}
                    <li><a href="{% url champions-my %}">Mes champions</a></li>
                    <li><a href="{% url champion-new %}">Envoyer un champion</a></li>
                    {% endif %}
                    <li><a href="{% url champions-all %}">Tous les champions</a></li>
                </ul>
            </div>
            <div class="block">
                <h1>Matches</h1>
                <ul>
                    {% if user.is_authenticated %}
                    <li><a href="{% url matches-my %}">Mes matches</a></li>
                    <li><a href="{% url match-new %}">Lancer un match</a></li>
                    {% endif %}
                    <li><a href="{% url matches-all %}">Tous les matches</a></li>
                    <li><a href="{% url status %}">Statut des serveurs</a></li>
                </ul>
            </div>
            <div class="block">
                <h1>Cartes</h1>
                <ul>
                    {% if user.is_authenticated %}
                    <li><a href="{% url map-new %}">Uploader une carte</a></li>
                    {% endif %}
                    <li><a href="{% url maps-all %}">Liste des cartes</a></li>
                </ul>
            </div>
            {% comment %}
            <div class="block">
                <h1>Tournois</h1>
                <ul>
                    <li><a href="/tournois/all/">Tous les tournois</a></li>
                </ul>
            </div>
            {% endcomment %}
            <div class="block">
                <h1>Mon compte</h1>
                <ul>
                    {% if user.is_authenticated %}
                    {% if user.is_staff %}
                    <li><a href="{% url admin:index %}">Administration</a></li>
                    {% endif %}
                    <li><a href="{% url logout %}">Déconnexion</a></li>
                    {% else %}
                    <li><a href="{% url login %}">Connexion</a></li>
                    {% endif %}
                </ul>
            </div>
            <div class="block">
                <h1>Liens relatifs</h1>
                <ul>
                    <li><a href="http://doc/">Documentation des langages</a></li>
                    <li><a href="http://wiki/">Wiki de documentation</a></li>
                </ul>
            </div>
        </nav>
        <div id="content">
            {% block "content" %}
            {% endblock %}
        </div>
    </body>
</html>

prologin/www/concours/stechec/templates/champion-delete.html
{% extends "base.html" %}

{% block "title" %}Envoi d'un champion{% endblock %}
{% block "titleh1" %}Envoi d'un champion{% endblock %}

{% block "content" %}

<p>Confirmez la suppression de votre champion :</p>

<form action="" method="post">
    {% csrf_token %}
    <p><input type="submit" value="Confirmer"></p>
</form>

{% endblock %}

prologin/www/concours/stechec/templates/champion-detail.html
{% extends "base.html" %}

{% block "title" %}Détails du champion - {{ champion.name }}{% endblock %}
{% block "titleh1" %}Détails du champion - {{ champion.name }}{% endblock %}
{% block "head" %}
<script type="text/javascript" src="{{ STATIC_URL }}js/jquery-1.5.2.min.js"></script>
{% endblock %}

{% block "content" %}

<dl>
    <dt>Nom</dt>
    <dd>{{ champion.name }}</dd>

    <dt>Auteur</dt>
    <dd>{{ champion.author }}</dd>

    <dt>État</dt>
    <dd>{{ champion.get_status_display }}</dd>

    <dt>Commentaire</dt>
    <dd>{{ champion.comment|linebreaksbr }}</dd>
</dl>

{% if champion.compilation_log and can_see_log %}
<p><a id="toggle-log" href="#">Afficher/cacher le log de compilation</a></p>
<pre id="log">{{ champion.compilation_log }}</pre>
<script type="text/javascript">
    $("#log").hide();
    $("#toggle-log").click(function() {
        $("#log").slideToggle();
    });
</script>
{% endif %}

{% endblock %}

prologin/www/concours/stechec/templates/champion-new.html
{% extends "base.html" %}

{% block "title" %}Envoi d'un champion{% endblock %}
{% block "titleh1" %}Envoi d'un champion{% endblock %}

{% block "content" %}

<form action="" method="post" enctype="multipart/form-data">
    {% csrf_token %}
    {{ form.as_p }}
    <p><input type="submit" value="Envoyer"></p>
</form>

{% endblock %}

prologin/www/concours/stechec/templates/champions-list.html
{% extends "base.html" %}

{% block "title" %}Tous les champions{% endblock %}
{% block "titleh1" %}Tous les champions{% endblock %}

{% block "content" %}

<p class="intro">{{ explanation_text }}</p>

{% if is_paginated %}{% load paginator %}{% paginator 5 %}{% endif %}

<table>
    <thead>
        <tr>
            <th>ID</th>
            <th>Nom</th>
            {% if show_for_all %}
            <th>Auteur</th>
            {% else %}
            <th>Statut</th>
            {% endif %}
            <th>Actions</th>
        </tr>
    </thead>
    <tbody>
        {% for champion in champions %}
        <tr class="{% cycle "row1" "row2" %}">
            <td>{{ champion.id }}</td>
            <td>{{ champion.name }}</td>
            {% if show_for_all %}
            <td>{{ champion.author }}</td>
            <td><a href="{{ champion.get_absolute_url }}">Détails</a></td>
            {% else %}
            <td>{{ champion.get_status_display }}</td>
            <td>
                <a href="{{ champion.get_absolute_url }}">Détails</a> -
                <a href="{{ champion.get_delete_url }}">Supprimer</a>
            </td>
            {% endif %}
        </tr>
        {% empty %}
        <tr>
            <td colspan="8">Aucun champion inscrit actuellement.</td>
        </tr>
        {% endfor %}
    </tbody>
</table>

{% endblock %}

prologin/www/concours/stechec/templates/login.html
{% extends "base.html" %}

{% block "title" %}Connexion{% endblock %}
{% block "titleh1" %}Connexion{% endblock %}

{% block "content" %}

{% if form.errors %}
<p>Erreur de connexion. Vérifiez que vous avez bien tapé votre login et votre mot de passe.</p>
{% endif %}

<form method="post" action="{% url login %}">
    {% csrf_token %}
    <input type="hidden" name="next" value="{{ next }}" />

    {{ form.as_p }}
    <p><input type="submit" value="Connexion" /></p>
</form>

{% endblock %}

prologin/www/concours/stechec/templates/map-detail.html
{% extends "base.html" %}

{% block "title" %}Détail du match{% endblock %}
{% block "titleh1" %}Détail du match{% endblock %}

{% block "content" %}

<dl>
    <dt>ID</dt>
    <dd>{{ map.id }}</dd>

    <dt>Nom</dt>
    <dd>{{ map.name }}

    <dt>Auteur</dt>
    <dd>{{ map.author }}</dd>

    <dt>Vue de la map</dt>
    <dd><pre>
{{ map.contents }}
    </pre></dd>
</dl>

{% endblock %}

prologin/www/concours/stechec/templates/map-new.html
{% extends "base.html" %}

{% block "title" %}Nouvelle map{% endblock %}
{% block "titleh1" %}Nouvelle map{% endblock %}

{% block "content" %}

<form action="" method="post">
    {% csrf_token %}
    {{ form.as_p }}
    <p><input type="submit" value="Envoyer"></p>
</form>

{% endblock %}

prologin/www/concours/stechec/templates/maps-list.html
{% extends "base.html" %}

{% block "title" %}Toutes les maps{% endblock %}
{% block "titleh1" %}Toutes les maps{% endblock %}

{% block "content" %}

<p class="intro">Cette page liste toutes les maps créées par les organisateurs et candidats du concours.</p>

{% if is_paginated %}{% load paginator %}{% paginator 5 %}{% endif %}

<table>
    <thead>
        <tr>
            <th>ID</th>
            <th>Officielle</th>
            <th>Nom</th>
            <th>Auteur</th>
            <th>Actions</th>
        </tr>
    </thead>
    <tbody>
        {% for map in maps %}
        <tr class="{% cycle "row1" "row2" %}{% if map.official %} official{% endif %}">
            <td>{{ map.id }}</td>
            <td>
                {% if map.official %}
                Oui
                {% else %}
                Non
                {% endif %}
            </td>
            <td>{{ map.name }}</td>
            <td>{{ map.author }}</td>
            <td><a href="{{ map.get_absolute_url }}">Détails</a></td>
        </tr>
        {% empty %}
        <tr>
            <td colspan="4">Aucune map n'est disponible actuellement.</td>
        </tr>
        {% endfor %}
    </tbody>
</table>

{% endblock %}

prologin/www/concours/stechec/templates/match-detail.html
{% extends "base.html" %}

{% load humanize %}
{% load substract %}

{% block "title" %}Détail du match{% endblock %}
{% block "titleh1" %}Détail du match{% endblock %}
{% block "head" %}
<script type="text/javascript" src="{{ STATIC_URL }}js/jquery-1.5.2.min.js"></script>
{% endblock %}

{% block "content" %}

<dl>
    <dt>ID</dt>
    <dd>{{ match.id }}</dd>

    <dt>Auteur</dt>
    <dd>{{ match.author }}</dd>

    <dt>État</dt>
    <dd>{{ match.get_status_display }}</dd>

    <dt>Date &amp; heure</dt>
    <dd>{{ match.ts|naturalday }} à {{ match.ts|time:"H:i:s" }}</dd>

    {% if match.is_done %}
    <dt>Replay</dt>
    <dd><a href="{% url match-dump match.id %}">Télécharger</a></dd>
    {% endif %}
</dl>

<h2>Participants</h2>
<table>
    <thead>
        <tr>
            <th>UID</th>
            <th>ID champion</th>
            <th>Champion</th>
            <th>Score</th>
            <th>Log</th>
        </tr>
    </thead>
    <tbody>
        {% for player in match.matchplayer_set.all %}
        <tr class="{% cycle "row1" "row2" %}">
            <td>{{ player.id|substract:match.matchplayer__id__min }}</td>
            <td>{{ player.champion.id }}</td>
            <td>{{ player.champion }}</td>
            {% if match.is_done %}
            <td>{{ player.score }}</td>
            <td>
                {% if user == match.champion.author or user.is_staff %}
                <p><a href="#" id="toggle-log-{{ player.id }}">Afficher / cacher le log</a></p>
                <pre id="log-{{ player.id }}">{{ player.log }}</pre>
                {% else %}
                -
                {% endif %}
            </td>
            {% else %}
            <td colspan="2">Non terminé</td>
            {% endif %}
        </tr>
        {% endfor %}
    </tbody>
</table>

{% if user.is_staff %}
<p><a href="#" id="toggle-serv-log">Afficher / cacher le log serveur</a></p>
<pre id="serv-log">{{ match.log }}</pre>
{% endif %}

<script type="text/javascript">
    {% for player in match.matchplayer_set.all %}
    $("#log-{{ player.id }}").hide();
    $("#toggle-log-{{ player.id }}").click(function() {
        $("#log-{{ player.id }}").slideToggle();
        return false;
    });
    {% endfor %}

    {% if user.is_staff %}
    $("#serv-log").hide();
    $("#toggle-serv-log").click(function() {
        $("#serv-log").slideToggle();
        return false;
    });
    {% endif %}
</script>

{% endblock %}

prologin/www/concours/stechec/templates/matches-list.html
{% extends "base.html" %}
{% load humanize %}

{% block "title" %}Tous les matches{% endblock %}
{% block "titleh1" %}Tous les matches{% endblock %}

{% block "content" %}

<p class="intro">{{ explanation_text }}</p>

{% if is_paginated %}{% load paginator %}{% paginator 5 %}{% endif %}

<table>
    <thead>
        <tr>
            <th>ID</th>
            <th>Date &amp; heure</th>
            <th>État</th>
            {% if show_creator %}<th>Créateur</th>{% endif %}
            <th>Carte</th>
            <th>Actions</th>
        </tr>
    </thead>
    <tbody>
        {% for match, map_name in matches %}
        <tr class="{% cycle "row1" "row2" %}">
            <td>{{ match.id }}</td>
            <td>{{ match.ts|naturalday }} à {{ match.ts|time:"H:i:s" }}</td>
            <td>{{ match.get_status_display }}</td>
            {% if show_creator %}<td>{{ match.author }}</td>{% endif %}
            <td>{{ map_name }}</td>
            <td><a href="{{ match.get_absolute_url }}">Détails</a></td>
        </tr>
        {% empty %}
        <tr>
            <td colspan="8">Aucun match réalisé pour le moment.</td>
        </tr>
        {% endfor %}
    </tbody>
</table>

{% endblock %}